%define api 	2
%define major	0
%define gmajor	2.0
%define libname	%mklibname %{name} %{api} %{major}
%define girname	%mklibname %{name}-gir %{gmajor}
%define devname	%mklibname %{name} %{api} -d

Name:		geoclue
Version:	2.7.1
Release:	%mkrel 1
Summary:	A modular geoinformation service
Group:		Geography
License:	GPLv2+
URL:		https://gitlab.freedesktop.org/geoclue/geoclue/wikis/home
Source0:	 https://gitlab.freedesktop.org/geoclue/geoclue/-/archive/%{version}/geoclue-%{version}.tar.xz
Patch0:		0001-Allow-redshift-to-use-agent.patch
#Patch2:		0001-Add-support-for-building-with-libsoup3.patch

BuildRequires:	meson
BuildRequires:	intltool
BuildRequires:	itstool
BuildRequires:	libxml2-utils
BuildRequires:	vala-devel
BuildRequires:	pkgconfig(avahi-client)
BuildRequires:	pkgconfig(avahi-glib)
BuildRequires:	pkgconfig(gio-2.0)
BuildRequires:	pkgconfig(gio-unix-2.0)
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(gobject-introspection-1.0)
BuildRequires:	pkgconfig(json-glib-1.0)
BuildRequires:	pkgconfig(libnm)
BuildRequires:	pkgconfig(libsoup-3.0)
BuildRequires:	pkgconfig(mm-glib)

# for demo agent
BuildRequires:	pkgconfig(libnotify)

Requires(pre):		rpm-helper
Requires(post):		rpm-helper
Requires(postun):	rpm-helper
Requires(preun):	rpm-helper

# for TLS/SSL support
Requires:	glib-networking

Provides:	geoclue2 = %{version}-%{release}

%description
Geoclue is a D-Bus service that provides location information. The
primary goal of the Geoclue project is to make creating location-aware
applications as simple as possible, while the secondary goal is to
ensure that no application can access location information without
explicit permission from user.

Geoclue used to also do (reverse-)geocoding but that functionality has
been dropped in favor of geocode-glib library.

However project is in the early stages of development and hence
lacking essential features. Currently it can only determine your
location based on your IP (i-e city-level accuracy) and does not have
any permission control.

%files
%{_datadir}/dbus-1/system.d/org.freedesktop.GeoClue2.conf
%{_datadir}/dbus-1/system.d/org.freedesktop.GeoClue2.Agent.conf
%dir %{_sysconfdir}/%{name}/
%{_sysconfdir}/%{name}/%{name}.conf
%{_sysconfdir}/xdg/autostart/geoclue-demo-agent.desktop
%{_datadir}/polkit-1/rules.d/org.freedesktop.GeoClue2.rules
%{_datadir}/dbus-1/system-services/org.freedesktop.GeoClue2.service
%{_datadir}/dbus-1/interfaces/org.freedesktop.GeoClue2.Agent.xml
%{_datadir}/dbus-1/interfaces/org.freedesktop.GeoClue2.xml
%{_datadir}/dbus-1/interfaces/org.freedesktop.GeoClue2.Client.xml
%{_datadir}/dbus-1/interfaces/org.freedesktop.GeoClue2.Location.xml
%{_datadir}/dbus-1/interfaces/org.freedesktop.GeoClue2.Manager.xml
%{_datadir}/applications/geoclue-demo-agent.desktop
%{_datadir}/applications/geoclue-where-am-i.desktop
%{_libexecdir}/geoclue-2.0/
%{_libexecdir}/geoclue
%{_mandir}
#--------------------------------------------------------------------

%package -n %{libname}
Summary:	Geoclue Client Library
Group:		System/Libraries

%description -n %{libname}
A convenience library to interact with Geoclue service.

%files -n %{libname}
%{_libdir}/libgeoclue-%{api}.so.%{major}
%{_libdir}/libgeoclue-%{api}.so.%{major}.*
%{_libdir}/girepository-1.0/Geoclue-%{gmajor}.typelib

#--------------------------------------------------------------------

%package -n %{devname}
Summary:	Development files for geoclue2
Group:		Development/Other
Obsoletes:	libgeoclue1.0-devel < 1.99.2
Obsoletes:	lib64geoclue1.0-devel < 1.99.2
Obsoletes:	%{name}-devel < 2.4.0
Provides:	%{name}-devel = %{version}-%{release}
Provides:	%{name}2-devel = %{version}-%{release}
# (tv) fix "No rule to make target '/usr/share/dbus-1/interfaces/org.freedesktop.GeoClue2.xml', needed by 'geoclue.h'":
Requires:	geoclue
Requires:	%{libname} = %{version}-%{release}

%description -n %{devname}
This package contains the development files for geoclue2.

%files -n %{devname}
%{_includedir}/libgeoclue-%{gmajor}/
%{_libdir}/pkgconfig/geoclue-%{gmajor}.pc
%{_libdir}/pkgconfig/libgeoclue-%{gmajor}.pc
%{_libdir}/libgeoclue-%{api}.so
%{_datadir}/gir-1.0/Geoclue-%{gmajor}.gir
%{_datadir}/vala/vapi/libgeoclue-%{api}.*

#--------------------------------------------------------------------
%prep
%setup -qn geoclue-%{version}
%autopatch -p1
# use specific api key
sed -i -e 's/key=geoclue/key=%{apikey}/g' data/geoclue.conf.in

%build
%meson -Dgtk-doc=false -Ddbus-srv-user=%{name}
%meson_build

%install
%meson_install

#we don't want these
find %{buildroot} -name "*.la" -delete

# home dir for geoclue
mkdir -p %{buildroot}%{_sharedstatedir}/geoclue

%pre
%_pre_useradd %{name} %{_sharedstatedir}/geoclue /sbin/nologin

%preun
%_preun_service %{name}

%post
%_post_service %{name}

%postun
%_postun_userdel %{name}


%changelog
* Wed Nov 29 2023 pp - 2.7.1-1pclos2023
- new version

* Sun Feb 05 2023 pp - 2.7.0-1pclos2023
- new version

* Wed Jan 04 2023 pp - 2.6.0-1pclos2023
- new version

* Tue Jan 12 2021 tex - 2.5.7-2pclos2021
- back down to 2.5.3

